<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';
require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources.'lib/validate_function.php';
require_once $base_path_to_learning.'branch_management/functions/functions.php';
require_once $base_path_to_learning.'user_management/authenticate.php';

//db access function
require_once $base_path_to_learning_resources.'includes/specific_db_config.php';

$postdata = json_decode(file_get_contents("php://input"), true);
checkIfNoPhpContentsReceive();

if (!isset($postdata['timetable_id']) or !checkIfIssetAndNotEmpty($postdata['timetable_id']) or
!isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or 
!isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or
!isset($postdata['jwt_token']) or  !checkIfIssetAndNotEmpty($postdata['jwt_token'])) {
    errorreturn("All * fields are required.");
}

validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is iin decodede data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$institution_id = $jwt_validate->data->institution_id;
$branch_id = $jwt_validate->data->branch_id;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,["principal"], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

require_once $base_path_to_learning . 'user_management/user_versioning.php';

$version = isset($_POST['version']) ? $_POST['version'] : (isset($postdata['version']) ? $postdata['version'] : null);
$updated_time = isset($_POST['updated_time']) ? $_POST['updated_time'] : (isset($postdata['updated_time']) ? $postdata['updated_time'] : null);

$response = user_data_refresh($conn_rjllearning, $conn_rjllearning_specific, $version, $updated_time, $userid, $institution_id);

if(!checkIfIssetAndNotEmpty($postdata['reg_id']))
{
    errorreturn("All * fields are required.");
}

// either the user has to fill gst or pan or ledgerhead 
function deleteTimetableDetails($conn_rjllearning, $conn_rjllearning_specific, $workspace_id, $institution_id, $branch_id, $timetable_id)
{
    $sql_stmt = "SELECT faculty_id FROM timetable WHERE id =? and institution_id = ? and branch_id =?";
    $statement = $conn_rjllearning_specific->prepare($sql);
    $statement->execute(array($timetable_id,$institution_id,$branch_id));
    $result = $statement->fetch();
    $faculty_id = $result['faculty_id'];
   
    $sql = "DELETE FROM timetable WHERE id =? and institution_id = ? and branch_id =?";
    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute(array($timetable_id,$institution_id,$branch_id));
    $count = $stmt->rowCount();
    if($count == 1) {
        return "Timetable Deleted Successfully";
    } else {
        errorreturn("Unable to delete timetable");
    }
    
    updateUserRoleTimestamp($conn_rjllearning, $conn_rjllearning_specific, $workspace_id, $institution_id, $faculty_id);
}

if($postdata['function_type']  == "delete_timetable") {  
    // $institution_id = trim($postdata['institution_id']);    
    $timetable_id = trim($postdata['timetable_id']);
    
    $success['data'] = deleteTimetableDetails($conn_rjllearning, $conn_rjllearning_specific, $workspace_id, $institution_id, $branch_id, $timetable_id);
    successreturn($success);
    
}